#pragma once

#if defined (_MSC_VER) && defined (_WIN32)
#   define CIH_WIN_BUILD
#   define CIH_PATH_SEPARATOR "\\"
#   if defined(_WIN32) && !defined(_WIN64)
#       define CIH_WORDSIZE 32
#   elif defined(_WIN32) && defined(_WIN64)
#       define CIH_WORDSIZE 64
#   else
#       error unsupported wordsize (32/64 platform)
#   endif
#   define CIH_WEAK_SYMBOL(s) __declspec(selectany) s
#elif defined(__GNUC__) && defined(__linux__)
#   define CIH_LINUX_BUILD
#   define CIH_PATH_SEPARATOR "/"
#   if __x86_64__ || __ppc64__ || __powerpc64__ || __aarch64__
#       define CIH_WORDSIZE 64
#   else
#       define CIH_WORDSIZE 32
#   endif
#   define CIH_WEAK_SYMBOL(s) s __attribute((weak))
#else
#   error unsupported platform
#endif

#define CIH_xstr_(v) CIH_str_(v)
#define CIH_str_(v) #v
#define CIH_WORDSIZE_STR CIH_xstr_( CIH_WORDSIZE )

#if defined CIH_WIN_BUILD
#   include <windows.h>
#endif
